
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <stdlib.h>

/*#define DBG*/

int bkmaze [128][128];
int maze [128][128];
   /*
      -1: zed
      0: nevyplneno
      1: pocet zlomu do tohoto mista
   */

int qi[128*128], qj[128*128];
int qbeg, qend;

int dirs[][2] = {{0,1}, {0,-1}, {1,0}, {-1,0}};


int main (void)
{
   FILE* fin = fopen ("game.in", "r");
   
   int task = 0;
   
   int w, h, i, j;
   while ( fscanf (fin, "%d %d", &w, &h) == 2 )
   {
      int pair = 0;
      fgetc (fin);

#ifdef DBG
      printf ("huhu: %d %d\n", w, h);
#endif
      
      if ( w == 0 && h == 0 )  break;
      memset (&maze, 0, sizeof (maze));
      for ( i = 0;  i < w+4;  ++i )
         maze[0][i] = maze[h+3][i] = -1;
      for ( i = 0;  i < h+4;  ++i )
         maze[i][0] = maze[i][w+3] = -1;
      
      for ( i = 2;  i < h+2;  ++i )
      {
         for ( j = 2;  j < w+2;  ++j )
         {
            int ch = fgetc (fin);
#ifdef DBG
 printf ("ch == %d\n", ch);
#endif
            if ( ch == 'X' )  maze[i][j] = -1;
         }
         fgetc (fin);
      }
      
      memcpy (&bkmaze, &maze, sizeof (maze));
      
      printf ("Board #%d:\n", ++task);
#if 0
for ( int ii = 0;  ii < h+4;  ++ii )
{
 for ( int jj = 0;  jj < w+4;  ++jj )
  printf ("%2d ", maze[ii][jj]);
 putchar ('\n');
}
#endif
      
      int si, sj, ti, tj;
      while ( fscanf (fin, "%d %d %d %d\n", &sj, &si, &tj, &ti) == 4 )
      {
         if ( sj == 0 )  break;
         ++sj;  ++si;  ++tj;  ++ti;
         memcpy (&maze, &bkmaze, sizeof (maze));
         qbeg = 0;  qend = 1;
         qi[0] = si;
         qj[0] = sj;

         while ( qbeg < qend )
         {
            int val = maze[qi[qbeg]][qj[qbeg]];
            if ( val < 0 )  val = 0;
            ++val;
            
            for ( int d = 0;  d < 4;  ++d )
            {
               int di=dirs[d][0], dj = dirs[d][1];
               int xi=qi[qbeg], xj=qj[qbeg];
               
               for ( ; ; )
               {
                  xi += di;  xj += dj;
                  if ( maze[xi][xj] != 0 &&
                        (ti != xi || tj != xj) )  break;
                  maze[xi][xj] = val;
                  qi[qend] = xi;
                  qj[qend++] = xj;
#ifdef DBG
  fprintf (stderr, "enqueing (%d,%d), val=%d\n", xi, xj, maze[xi][xj]);
#endif
               }
            }
            
            ++qbeg;
            if ( maze[ti][tj] > -1 )  break;
         }
         
         printf ("Pair %d: ", ++pair);
         if ( maze[ti][tj] > -1 )
            printf ("%d segments.\n", maze[ti][tj]);
         else
            printf ("impossible.\n");
      }
      
      printf ("\n");
   }
   
   fclose (fin);
   return 0;
}
