
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <stdlib.h>


/*#define DBG*/


char pos[128][128][128];
int w, h, t, dd;


void fillit (int s, int x, int y)
{
   if ( pos[s][x][y] != 0 )  return;
   pos[s][x][y] = 1;
   if ( s == t && dd == 1 )  return;
   if ( s == 1 && dd == -1 )  return;
   fillit (s+dd, x, y);
   fillit (s+dd, x+1, y);
   fillit (s+dd, x, y+1);
   fillit (s+dd, x-1, y);
   fillit (s+dd, x, y-1);
}


int unfill (void)
{
   int chg = 0;

#ifdef DBG
   for ( int i = 1;  i <= t;  ++i )
   {
     printf ("layer %d:\n", i);
     for ( int j = 1;  j <= w;  ++j )
     {
       for ( int k = 1;  k <= h;  ++k )
       {
         printf ("%2d ", pos[i][j][k]);
       }
       putchar ('\n');
     }
   }

#endif

   for ( int i = 1;  i <= t;  ++i )
   for ( int j = 1;  j <= w;  ++j )
   for ( int k = 1;  k <= h;  ++k )
   {
      if ( pos[i][j][k] == 1 )  pos[i][j][k] = 0;
      else if ( pos[i][j][k] == 0 )
      {
         pos[i][j][k] = -2;
         chg = 1;
      }
   }
   
   return !chg;
}


int main (void)
{
   FILE* fin = fopen ("robbery.in", "r");
   int task = 0;
   
   while ( fscanf (fin, "%d %d %d\n", &w, &h, &t) == 3 )
   {
      if ( w == 0 )  break;
      
      memset (&pos, 0, sizeof (pos));
      
      int cnt;
      fscanf (fin, "%d\n", &cnt);
      for ( int i = 0;  i < cnt;  ++i )
      {
         int s, x1, y1, x2, y2;
         int d = 0;
         fscanf (fin, "%d %d %d %d %d\n", &s, &x1, &y1, &x2, &y2);
         ++y2; ++x2;
         while ( x1 < x2 && y1 < y2 )
         {
            for ( int x = x1;  x < x2;  ++x )
               for ( int y = y1;  y < y2;  ++y )
               {
                  if ( s+d <= t )  pos[s+d][x][y] = -1;
                  if ( s-d >= 1 )  pos[s-d][x][y] = -1;
               }
            ++d;
            ++x1; ++y1; --x2; --y2;
         }
      }
      
      for ( ; ; )
      {
         dd = 1;
         for ( int x = 1;  x <= w;  ++x )
            for ( int y = 1;  y <= h;  ++y )
               fillit (1, x, y);
         if ( unfill() )  break;
         
         dd = -1;
         for ( int x = 1;  x <= w;  ++x )
            for ( int y = 1;  y <= h;  ++y )
               fillit (t, x, y);
         if ( unfill() )  break;
      }
      
      printf ("Robbery #%d:\n", ++task);
      int wasinfo = 0, waspos = 0;
      for ( int s = 1;  s <= t;  ++s )
      {
         int cntpos = 0;
         int xi, xj;
         
         for ( int i = 1;  i <= w;  ++i )
         for ( int j = 1;  j <= h;  ++j )
         if ( pos[s][i][j] == 0 )
         {
            ++cntpos;
            xi = i;  xj = j;
         }
         
         if ( cntpos > 0 )  waspos = 1;
         if ( cntpos == 1 )
         {
            printf ("Time step %d: The robber has been at %d,%d.\n",
                  s, xi, xj);
            wasinfo = 1;
         }
      }
      
      if ( !wasinfo )
         printf ("Nothing known.\n");
      else if ( !waspos )
         printf ("The robber has escaped.\n");
      
      printf ("\n");
   }
   
   fclose (fin);
   return 0;
}
